#!/usr/bin/env bash
set -euo pipefail
SF=${1:-1}
SCRIPTDIR="$PWD"
echo "Generating TPC-H .tbl files $SCRIPTDIR/tpch/*.tbl with scale factor $SF"

mkdir -p tpch
mkdir -p tmp
cd tmp
echo '3045d758d1506ce37a354f1b34d44129  tpch-kit.zip' | md5sum --check --status 2>/dev/null || curl -L https://github.com/gregrahn/tpch-kit/archive/852ad0a5ee31ebefeed884cea4188781dd9613a3.zip > tpch-kit.zip
echo '3045d758d1506ce37a354f1b34d44129  tpch-kit.zip' | md5sum --check --status
unzip -u tpch-kit.zip

(
  cd tpch-kit-852ad0a5ee31ebefeed884cea4188781dd9613a3/dbgen
  make -sj "$(nproc)" dbgen 2>/dev/null
  ./dbgen -f -s "$SF"
  cp *.tbl "$SCRIPTDIR/tpch"
)

